package io.gitlab.jfronny.translater;

import me.sargunvohra.mcmods.autoconfig1u.ConfigData;
import me.sargunvohra.mcmods.autoconfig1u.annotation.Config;
import me.sargunvohra.mcmods.autoconfig1u.annotation.ConfigEntry;
import me.sargunvohra.mcmods.autoconfig1u.shadowed.blue.endless.jankson.Comment;

@Config(name = "TranslaterCF")
public class Cfg implements ConfigData {
    @Comment("NOTE: remove the cache after you change the config!\nRegenerating the cache can take up to 3 hours for vanilla (5000 strings)\nWatch the log when in doubt\n\nThe amount of times to translate each element")
    public int rounds = 5;
    @Comment("Whether to fully break the texts content by translating from the wrong language (enable for complete breaking)")
    public boolean breakFully = false;
    @Comment("The API key for Yandex Translate (this is REQUIRED for updating the cache, since Yandex doesn't give them out for free anymore you might want to google \"trnsl.1.1.\" to find keys on the web)")
    public String key = "trnsl.1.1.20130811T164454Z.2facd8a3323b8111.e9f682063308aff12357de3c8a3260d6d6b71be7";
    @Comment("The language to translate to - Leave empty for auto-detection (might break text even more)")
    public String targetLanguage = "en";
    @Comment("Significantly slows down the loading time but gives a visual of the progress. Values: Full, Console, None")
    @ConfigEntry.Gui.EnumHandler(option = ConfigEntry.Gui.EnumHandler.EnumDisplayOption.BUTTON)
    public progressMode renderProgress = progressMode.None;
    @Comment("Use this if something is broken. This initiates the regeneration of the cache")
    @ConfigEntry.Gui.RequiresRestart
    public boolean forceRegenerate = false;

    public enum progressMode {
        Full,
        Console,
        None
    }
}
