package io.gitlab.jfronny.translater;

import io.gitlab.jfronny.translater.transformer.CachingTransformer;
import io.gitlab.jfronny.translater.transformer.TransformingMap;
import io.gitlab.jfronny.translater.transformer.YnTransformer;
import me.sargunvohra.mcmods.autoconfig1u.AutoConfig;
import me.sargunvohra.mcmods.autoconfig1u.serializer.JanksonConfigSerializer;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Map;

@Environment(EnvType.CLIENT)
public class Translater implements ClientModInitializer {
    public static final String MOD_NAME = "Translater";
    public static final String MOD_ID = "translater";
    private static final Logger logger;
    public static Cfg cfg;
    private static TransformingMap map;

    static {
        AutoConfig.register(Cfg.class, JanksonConfigSerializer::new);
        cfg = AutoConfig.getConfigHolder(Cfg.class).getConfig();
        logger = LogManager.getFormatterLogger(MOD_ID);
    }

    @Override
    public void onInitializeClient() {

    }

    public static boolean Gui() {
        return cfg.renderProgress == Cfg.progressMode.Full;
    }
    public static boolean Cli() {
        return cfg.renderProgress == Cfg.progressMode.Full || cfg.renderProgress == Cfg.progressMode.Console;
    }

    public static void Warn(String msg) {
        logger.log(Level.WARN, "[" + MOD_NAME + "] " + msg);
    }

    public static void Log(String msg) {
        logger.log(Level.INFO, "[" + MOD_NAME + "] " + msg);
    }

    public static TransformingMap getMap(Map<String, String> base) {
        if (map == null) {
            map = new TransformingMap(base, new CachingTransformer(new YnTransformer()));
            map.init();
        }
        return map;
    }

    public static TransformingMap getMap() {
        return map;
    }
}
